﻿using System;
using System.Windows.Input;
using System.Windows.Media;

namespace SilverlightKidsDoodler
{
    public class PaletteColor : PaletteItem
    {
        public event EventHandler<PaletteColorSelectedEventArgs> PaletteColorSelected;

        public Brush Color
        {
            get { return _content.Background; }
            set { _content.Background = value; }
        }

        protected override void HandleMouseLeftButtonDown(object sender, MouseEventArgs e)
        {
            // Fire corresponding event
            EventHandler<PaletteColorSelectedEventArgs> handler = PaletteColorSelected;
            if (null != handler)
            {
                handler.Invoke(this, new PaletteColorSelectedEventArgs { Color = ((SolidColorBrush)Color).Color });
            }
        }
    }

    public class PaletteColorSelectedEventArgs : EventArgs
    {
        public Color Color { get; set; }
    }
}
