﻿using System.IO;
using System.Windows.Controls;
using System.Windows.Input;

namespace SilverlightKidsDoodler
{
    public class PaletteItem : Control
    {
        protected Canvas _content;
        protected TextBlock _textBlock;

        public PaletteItem()
        {
            // Load XAML content
            using (var resourceStream = typeof(PaletteItem).Assembly.GetManifestResourceStream("SilverlightKidsDoodler.PaletteItem.xaml"))
            {
                _content = (Canvas)InitializeFromXaml(new StreamReader(resourceStream).ReadToEnd());
            }
            _textBlock = (TextBlock)_content.FindName("textBlock");
            // Hook events
            MouseLeftButtonDown += new MouseEventHandler(HandleMouseLeftButtonDown);
        }

        protected virtual void HandleMouseLeftButtonDown(object sender, MouseEventArgs e)
        {
            // Override this method in child classes
        }

        public void Layout(double width, double height)
        {
            // Layout control/content
            Width = width;
            Height = height;
            _content.Width = Width;
            _content.Height = Height;
            // Center text
            _textBlock.SetValue(Canvas.LeftProperty, (Width - _textBlock.ActualWidth) / 2);
            _textBlock.SetValue(Canvas.TopProperty, (Height - _textBlock.ActualHeight) / 2);
        }
    }
}
